* purge ctdlsvc.c
[citadel.git] / citadel / debian / citadel.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          skeleton
4 # Required-Start:    $local_fs $remote_fs
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Example initscript
9 # Description:       This file should be used to construct scripts to be
10 #                    placed in /etc/init.d.
11 ### END INIT INFO
12
13 # Author: Foo Bar <foobar@baz.org>
14 #
15 # Please remove the "Author" lines above and replace them
16 # with your own name if you copy and modify this script.
17
18 # Do NOT "set -e"
19
20 # PATH should only include /usr/* if it runs after the mountnfs.sh script
21 RUNDIR=/var/run/citadel
22 PATH=/sbin:/usr/sbin:/bin:/usr/bin
23 DESC="Citadel Groupware "
24 NAME=citserver
25 DAEMON=/usr/sbin/$NAME
26 DAEMON_ARGS=" -d -x3 -lmail -t/dev/null"
27 PIDFILE=$RUNDIR/$NAME.pid
28 SCRIPTNAME=/etc/init.d/citadel
29 SENDCOMMAND=/usr/sbin/sendcommand
30
31
32 # Exit if the package is not installed
33 [ -x "$DAEMON" ] || exit 0
34
35 # Read configuration variable file if it is present
36 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
37
38 MODERN=
39
40 # Load the VERBOSE setting and other rcS variables
41 if test -f /lib/init/vars.sh ; then
42     . /lib/init/vars.sh
43     MODERN=1
44 fi
45 # Define LSB log_* functions.
46 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
47 if test -f /lib/lsb/init-functions; then
48     . /lib/lsb/init-functions
49     MODERN=1
50 fi
51
52 #
53 # Function that starts the daemon/service
54 #
55 do_start()
56 {
57         # for ubuntu: check our volatile dirs.
58         if test ! -d $RUNDIR; then
59             mkdir -p $RUNDIR
60         fi
61         # Return
62         #   0 if daemon has been started
63         #   1 if daemon was already running
64         #   2 if daemon could not be started
65         if $DAEMON \
66                 $DAEMON_ARGS ; then
67             return 0
68         else
69             return 2
70         fi
71         # Add code here, if necessary, that waits for the process to be ready
72         # to handle requests from services started subsequently which depend
73         # on this one.  As a last resort, sleep for some time.
74 }
75
76 #
77 # Function that stops the daemon/service
78 #
79 do_stop()
80 {
81         # Return
82         #   0 if daemon has been stopped
83         #   1 if daemon was already stopped
84         #   2 if daemon could not be stopped
85         #   other if a failure occurred
86         if $SENDCOMMAND "DOWN" >/dev/null 2>&1 ; then
87             rm -f $PIDFILE
88
89             while test -S /var/run/citadel/citadel.socket; do 
90                 sleep 1
91                 echo -n "."
92             done
93                 return 0
94         else
95             rm -f $PIDFILE
96             return 2
97         fi
98
99         #while test -d /proc/`cat $PIDFILE`; do
100         #    /usr/bin/printf  '.'
101         #    /bin/sleep 1
102         #done
103  
104         #start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
105         #RETVAL="$?"
106         #[ "$RETVAL" = 2 ] && return 2
107         # Wait for children to finish too if this is a daemon that forks
108         # and if the daemon is only ever run from this initscript.
109         # If the above conditions are not satisfied then add some other code
110         # that waits for the process to drop all resources that could be
111         # needed by services started subsequently.  A last resort is to
112         # sleep for some time.
113         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
114         #[ "$?" = 2 ] && return 2
115         # Many daemons don't delete their pidfiles when they exit.
116         # rm -f $PIDFILE
117 }
118
119 #
120 # Function that sends a SIGHUP to the daemon/service
121 #
122 do_reload() {
123         #
124         # If the daemon can reload its configuration without
125         # restarting (for example, when it is sent a SIGHUP),
126         # then implement that here.
127         #
128 #       start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
129         do_stop
130         do_start
131         return 0
132 }
133
134 case "$1" in
135   start)
136         if test -n "$MODERN"; then
137             [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
138         else
139             echo "Starting $DESC" "$NAME"
140         fi
141
142         do_start
143         if test -n "$MODERN"; then
144             case "$?" in
145                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
146                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
147             esac
148         fi
149         ;;
150   stop)
151         if test -n "$MODERN"; then
152             [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
153         else
154             echo "Stopping $DESC" "$NAME"
155         fi
156         do_stop
157         if test -n "$MODERN"; then
158             case "$?" in
159                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
160                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
161             esac
162         fi
163         ;;
164   #reload|force-reload)
165         #
166         # If do_reload() is not implemented then leave this commented out
167         # and leave 'force-reload' as an alias for 'restart'.
168         #
169         #log_daemon_msg "Reloading $DESC" "$NAME"
170         #do_reload
171         #log_end_msg $?
172         #;;
173   restart|force-reload)
174         #
175         # If the "reload" option is implemented then remove the
176         # 'force-reload' alias
177         #
178         if test -n "$MODERN"; then
179             log_daemon_msg "Restarting $DESC" "$NAME"
180         else
181             echo "Restarting $DESC" "$NAME"
182         fi
183
184         do_stop
185
186         if test -n "$MODERN"; then
187             case "$?" in
188                 0|1)
189                     do_start
190                     case "$?" in
191                         0) log_end_msg 0 ;;
192                         1) log_end_msg 1 ;; # Old process is still running
193                         *) log_end_msg 1 ;; # Failed to start
194                     esac
195                     ;;
196                 *)
197                 # Failed to stop
198                     log_end_msg 1
199                     ;;
200             esac
201         fi
202         ;;
203   *)
204         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
205         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
206         exit 3
207         ;;
208 esac
209
210 :